#!/usr/bin/python
#-*- coding:utf-8 –*-

import re #regular expression
import os
import sys
import glob
import StringIO
import itertools
from GBaseConnector import connect,GBaseError

#The params of gbase 8a connect
config = {'host':'192.168.222.160','port':5258,'database':'test','user':'gbase','passwd':'gbase20110531','use_unicode':False}

#先修改procFilesDir变量，procFilesDir是存放存储过程或者SQL集的目录
procFilesDir = "/mnt/hgfs/share2vm133/tmp"

def getTableNameFromAlias(sourceStr,aliasName):
    tableName = ""
    tableNameft = re.finditer('\\b[fromjnit]{4}\\b[\s]+([\S]*[\s]*\\b' + aliasName +"\\b)",sourceStr,re.I|re.M) #匹配join、from、merge into后面的表名，子查询分布键不能获取到
    for match in tableNameft:
        tableName = match.group(1).split(' ')[0].strip(')')
        
    
    return tableName

def getJoinTablesColumn(sourceStr):
    tableandkeyVal = []
    section = re.finditer('[\s\S]+?;',sourceStr,re.I|re.M)
    for match in section: 
        #非子查询的关联
        con = re.finditer('\\bon\\b[\s]+[\(]?[\s]*([0-9a-zA-Z_\.]+)[\s]*=[\s]*([0-9a-zA-Z\._]+)[\s]*[\)]?',match.group(),re.I|re.M)
        for joinColumn in con:
            aliasA = joinColumn.group(1).split('.')[0]
            aliasB = joinColumn.group(2).split('.')[0]
            tableleft = getTableNameFromAlias(match.group(),aliasA)
            tableright = getTableNameFromAlias(match.group(),aliasB)
            if tableleft!='':
                tableandkeyVal.append(getTableNameFromAlias(match.group(),aliasA) + ":" + joinColumn.group(1).split('.')[-1])
            if tableright!='':
                tableandkeyVal.append(getTableNameFromAlias(match.group(),aliasB) + ":" + joinColumn.group(2).split('.')[-1])

    return tableandkeyVal
    
def modifyDBTableDistributeKey(tablename,disKeyName):
    try:
        conn = connect()
        conn.connect(**config)
        cur = conn.cursor()
        cur.execute("show create table " + tablename)
        columns = cur.fetchall()
        tableDDL = columns[0][1] #获取结果的建表语句列
        tableDDL=re.sub('distributed[\s]+by[\s]*\(.*\)','',tableDDL,0,re.I|re.M)
        #获取列的类型
        matchStr="\""+disKeyName.strip()+"\"[\s]+([0-9a-zA-Z]+)"
        columnType = re.finditer(matchStr,tableDDL,re.I|re.M)
        for match in columnType:
            if (match.group(1) == "varchar" or match.group(1) == "int" or match.group(1) == "bigint" or match.group(1) == "decimal"):
                cur.execute("drop table " + tablename) #先删除原表
                cur.execute(tableDDL + "distributed by('" + disKeyName + "')") #用合适的分布键重新创建表
                   
    except GBaseError.DatabaseError, err:
        print err
    finally:
        conn.close()
        
def getSubQuery(sourceStr):
    returnContents="";
    subQs=re.finditer('\([\s]*select',sourceStr,re.I|re.M);
    for match in subQs:
        startPos=match.span()[0];
        leftParenthesesCnt=1;
        loopCnt=0;
        while True:
            if sourceStr[loopCnt+startPos]=='(':
                leftParenthesesCnt=leftParenthesesCnt+1;
                if leftParenthesesCnt==1:
                    break;
            elif sourceStr[loopCnt+startPos]==')':
                leftParenthesesCnt=leftParenthesesCnt-1;
                if leftParenthesesCnt==1:
                    break;
            loopCnt=loopCnt+1;
        returnContents=returnContents+sourceStr[startPos:startPos+loopCnt+1]+'\n&';
    return returnContents.rstrip('&\n');

    
'''
主程序
''' 
retdic = {}  
for filename in glob.glob(procFilesDir + '/*'):
    with open(filename,'r') as f:
        contents=f.read().rstrip();
        contents=re.sub('  ',' ',contents,0,re.I|re.M)
        contents=re.sub('\t',' ',contents,0,re.I|re.M)
        contents=re.sub('\r\n','\n',contents,0,re.I|re.M)
        
        listre = getJoinTablesColumn(contents)
        for item in listre:
            #print "item %s has found %d" %(item,listre.count(item))
            retdic[item] = listre.count(item)

listtable = []            
for item in retdic.keys():
    listtable.append(item.split(':')[0])

for tn in set(listtable):
    maxval = 0
    maxvalColumnName = ""
    print "\033[0;30;41m<"+ tn + ">\033[0m"
    for tname in retdic.keys():
        if (tn == tname.split(':')[0]):
            if retdic[tname] > maxval:
                maxval = retdic[tname]
                maxvalColumnName = tname.split(':')[1]
            print "字段 "+tname.split(':')[1] + " 使用次数:" + str(retdic[tname])
            
    print "使用合适的分布键修改数据库中的表结构，表名：" + tn +" 分布键名：" + maxvalColumnName
    modifyDBTableDistributeKey(tn,maxvalColumnName)
        
        
