#!/usr/bin/python
#-*- coding:utf-8 –*-

import re #regular expression
import os
import sys
import glob
import StringIO
import itertools

instanceNum = 2

#1个numa组绑定1个或多个实例,2个numa组
twoNumaNodeToGnodeStr = '''
	#$2 > /dev/null 2>&1 &			
	 if [ $1 = 'gbase' ];then
		count_numa=$(($(($3))%2))
		echo  "--cpunodebind=+$count_numa --membind=+$count_numa"
		numactl --cpunodebind=+"${count_numa}" --membind=+"${count_numa}" $2 > /dev/null 2>&1 &
		sleep 10
        else
                $2 > /dev/null 2>&1 &
        fi	
	# waiting for start completely
'''
#1个numa组绑定1个或多个实例,4个numa组
fourNumaNodeToGnodeStr = '''
        #$2 > /dev/null 2>&1 &
         if [ $1 = 'gbase' ];then
                count_numa=$(($(($3))%4))
                echo  "--cpunodebind=+$count_numa --membind=+$count_numa"
                numactl --cpunodebind=+"${count_numa}" --membind=+"${count_numa}" $2 > /dev/null 2>&1 &
                sleep 10
        else
                $2 > /dev/null 2>&1 &
        fi
        # waiting for start completely
'''
#1个numa组绑定1个或多个实例,8个numa组
eightNumaNodeToGnodeStr = '''
        #$2 > /dev/null 2>&1 &
         if [ $1 = 'gbase' ];then
                count_numa=$(($(($3))%8))
                echo  "--cpunodebind=+$count_numa --membind=+$count_numa"
                numactl --cpunodebind=+"${count_numa}" --membind=+"${count_numa}" $2 > /dev/null 2>&1 &
                sleep 10
        else
                $2 > /dev/null 2>&1 &
        fi
        # waiting for start completely
'''
#两个numa组绑定1个实例
twoNumaNodeToOneGnodeStr = '''
	 #$2 > /dev/null 2>&1 &
	 if [ $1 = 'gbase' ];then
		numa1=$[$3*2]
		numa2=$[$3*2+1]
		echo  "--cpunodebind=+$numa1,$numa2 --membind=+$numa1,$numa2"
		numactl --cpunodebind=+"${numa1},${numa2}" --membind=+"${numa1},${numa2}" $2 > /dev/null 2>&1 &
		sleep 10
        else
                $2 > /dev/null 2>&1 &
        fi
	# waiting for start completely
'''

otherReplace = '''
		# start data service
		if [ $node_type == 2 -o $node_type == 3 ]; then
			for ((count=0; count<${#DataServerName[@]}; count++))
			do
				instance_no=0
                		for inst in `echo $GBASE_INSTANCES|sed 's/:/\\n/g'|sort|uniq`
                		do
                    			if [ $inst != "" ];then
                        			#echo $inst
                        			. $inst
                        			declare -a DataServerBin
                        			DataServerBin[0]=$GBASE_HOME/bin/gbased
                        			DataServerBin[1]=$GBASE_HOME/bin/gc_sync_server
                        			#echo ${DataServerBin[count]}
                       				__start ${DataServerName[count]} ${DataServerBin[count]} ${instance_no} 
                        			if [ "$?" != "$RET_SUCCESS" ]; then
                            				ret_start=$RET_START_ALL_ERROR
                        			fi
						((instance_no++))
                    			fi
                		done
'''

#检测numam命令是否存在，不存在则退出
numactlCommandCheck = os.popen("numactl -s").read()
if "physcpubind" in str(numactlCommandCheck):
	print ("[INFO]numactl package is installed,continue...")
else:
	print ("[ERROR]numactl not exists ,pls install numactl command.")
	sys.exit(1)

#检测numa信息
numanodesNum = os.popen("numactl -H|grep available|awk '{print $2}'").read().strip()
if int(numanodesNum) > 1:
	print ("[INFO]Have Multipule numanodes,Num = %s") % (numanodesNum)
else:
	print ("[INFO]Have not Numa or Numanodes less than 1,not necessary band numa.") 

#Modify gclster_services file to support multi gnodes
gclusterServicesPath = os.popen("which gcluster_services").read().strip()
with open(gclusterServicesPath,'r') as servicesFile:
	fileContent = servicesFile.read()
	findBindPlace = re.finditer('\$2[\s]*>[\s]*/dev/null[\s]+2>&1[\s]*&[\s]*#[\s]*waiting[\s]*for[\s]*start[\s]*completely',fileContent,re.I|re.M)
        for match in findBindPlace:
		#一个numa组绑定一个或多个gnode实例
		if instanceNum >= int(numanodesNum):
			if int(numanodesNum) == 2:
				fileContent = fileContent.replace(match.group(),twoNumaNodeToGnodeStr)
			elif int(numanodesNum) == 4:
				fileContent = fileContent.replace(match.group(),fourNumaNodeToGnodeStr)
			elif int(numanodesNum) == 8:
				fileContent = fileContent.replace(match.group(),eightNumaNodeToGnodeStr)
			else:
				print ("Not necessary Band,exit.")
				sys.exit(1)
		
		#补充其他numa绑定的情况
	replacePlace1 = re.finditer('#[\s]*start[\s]*data[\s]*service[\s\S]*?for[\s]*\(\([\s]*count[\s]*=[\s]*0[\s]*;[\s]*count[\s]*<[\s]*\$[\s]*\{[\s]*\#[\s]*DataServerName\[@\]\}[\s]*;[\s]*count\+\+[\s]*\)[\s]*\)[\s]*do[\s\S]*?done',fileContent,re.I|re.M)
	for match in replacePlace1:
		fileContent = fileContent.replace(match.group(),otherReplace)
#写入修改后的内容到文件，当前目录下的生成文件名：gcluster_services
with open('./gcluster_services','w+') as fout:	
	fout.write(fileContent)
