#!/usr/bin/python
#-*- coding:utf-8 –*-

#使用方式：
#新建一个目录，把原始的ddl放到这个目录,比如ori
#新建另外一个目录，用来存入转换后的ddl,比如gba
#命令：python ntzddl2gb.py ori gba

import re #regular expression
import os
import sys
import glob
import itertools

inputpath = sys.argv[1] + '/*'; 
outputpath = sys.argv[2]; 

keyWords={'ACCESSIBLE','ADD','ALL','ALTER','ANALYZE','AND','AS','ASC','ASENSITIVE','BEFORE','BETWEEN','BIGINT','BINARY','BLOB','BOTH','BY','CALL','CASCADE','CASE','CHANGE','CHAR','CHARACTER','CLUSTER','COLLATE','COLUMN','COMPRESS','CONDITION','CONNECT','CONSTRAINT','CONTINUE','CONVERT','CREATE','CROSS','CURRENT_DATE','CURRENT_DATETIME','CURRENT_TIME','CURRENT_TIMESTAMP','CURRENT_USER','CURSOR','DATABASE','DATABASES','DAY_HOUR','DAY_MICROSECOND','DAY_MINUTE','DAY_SECOND','DEC','DECIMAL','DECLARE','DEFAULT','DELAYED','DELETE','DESC','DESCRIBE','DETERMINISTIC','DISTINCT','DISTINCTROW','DISTRIBUTE','DISTRIBUTED','DIV','DOUBLE','DROP','DUAL','EACH','ELSE','ELSEIF','ENCLOSED','ESCAPED','EXISTS','EXIT','EXPLAIN','EXCEPT','FALSE','FETCH','FLOAT','FLOAT4','FLOAT8','FOR','FORCE','FOREIGN','FROM','FULL','FULLTEXT','GCEXPORT','GCIMPORT','GCLOCAL','GCLUSTER','GCLUSTER_LOCAL','GET','GRANT','GROUP','GROUPED','HAVING','HIGH_PRIORITY','HOUR_MICROSECOND','HOUR_MINUTE','HOUR_SECOND','IF','IGNORE','IN','INDEX','INFILE','INITNODEDATAMAP','INNER','INOUT','INSENSITIVE','INSERT','INT','INT1','INT2','INT3','INT4','INT8','INTEGER','INTERSECT','INTERVAL','INTO','IS','ITERATE','JOIN','KEY','KEYS','KILL','LEADING','LEAVE','LEFT','LEVEL','LIKE','LIMIT','LIMIT_STORAGE_SIZE','LINEAR','LINES','LINK','LOAD','LOCALTIME','LOCALTIMESTAMP','LOCK','LONG','LONGBLOB','LONGTEXT','LOOP','LOW_PRIORITY','MATCH','MEDIUMBLOB','MEDIUMINT','MEDIUMTEXT','MERGE','MIDDLEINT','MINUS','MINUTE_SECOND','MOD','MODIFIES','NATURAL','NOCOPIES','NOCYCLE','NULL','NUMERIC','ON','OPTIMIZE','OPTION','OPTIONALLY','OR','ORDER','ORDERED','OUT','OUTER','OUTFILE','OVER','PRIMARY','PRIOR','PROCEDURE','PURGE','RANGE','READ','READS','READ_WRITE','REAL','REFERENCES','REFRESH','REGEXP','RELEASE','RENAME','REPEAT','REPLACE','REQUIRE','RESTRICT','RETURN','REVERT','REVOKE','RIGHT','RLIKE','SCHEMA','SCHEMAS','SCN_NUMBER','SECOND_MICROSECOND','SELECT','SELF','SENSITIVE','SEPARATOR','SET','SHOW','SMALLINT','SORT','SPATIAL','SPECIFIC','SQL','SQLEXCEPTION','SQLSTATE','SQLWARNING','SQL_BIG_RESULT','SQL_SMALL_RESULT','SSL','START','STARTING','STRAIGHT_JOIN','TABLE','TARGET','TERMINATED','THEN','TINYBLOB','TINYINT','TINYTEXT','TO','TRAILING','TRIGGER','TRUE','UNDO','UNION','UNIQUE','UNLOCK','UNSIGNED','UPDATE','USAGE','USE','USING','UTC_DATE','UTC_DATETIME','UTC_TIME','UTC_TIMESTAMP','VALUES','VARBINARY','VARCHAR','VARCHARACTER','VARYING','WHEN','WHERE','WHILE','WITH','WRITE','XOR','YEAR_MONTH','ZEROFILL','LEVEL','TARGET'};

def getFunContent(sourceStr,funcName,onlyColumn):
    returnContents="";
    funcCotents=re.finditer(funcName,sourceStr,re.I|re.M);
    for match in funcCotents:
        funcstr=''.join(match.group());
        startPos=match.span()[0]+len(funcstr);
        leftParenthesesCnt=1;
        loopCnt=0;
        while True:
            if loopCnt+startPos == len(sourceStr):
                break;
            if sourceStr[loopCnt+startPos]=='(':
                leftParenthesesCnt=leftParenthesesCnt+1;
                if leftParenthesesCnt==1:
                    break;
            elif sourceStr[loopCnt+startPos]==')':
                leftParenthesesCnt=leftParenthesesCnt-1;
                if leftParenthesesCnt==1:
                    break;
            loopCnt=loopCnt+1;
        returnContents=returnContents+sourceStr[startPos:startPos+loopCnt+1]+'&';
    if (onlyColumn == 1):
        return ''.join(returnContents.strip('&').split('&'));
    elif (onlyColumn == 0):
        return funcstr+''.join(returnContents.strip('&').split('&'));
    else:
        return "param value not support!"

#列名关键字加包围符
def addEncloseToKeywordColumn(srcStr):
    onlyColumnDDL=getFunContent(srcStr,'create[\s]+table[\s]+[\S]+[\s]*',1);
    onlyColumnDDL_ori = onlyColumnDDL;
    #下面代码的会跳过第一列
    findColumns=re.finditer(',[\s]*(["a-zA-Z0-9()_]+)[\t ]+[a-zA-Z0-9()]+',onlyColumnDDL,re.I|re.M); 
    for match in findColumns:
        columnName = match.group(1);
        if columnName.upper() in keyWords:
            columnName_n = '`'+columnName+'`';
            onlyColumnDDL = onlyColumnDDL.replace(columnName,columnName_n);
    srcStr = srcStr.replace(onlyColumnDDL_ori,onlyColumnDDL); 
    onlyColumnDDL_ori = onlyColumnDDL;
    #处理第一列
    findColumns=re.finditer('\([\s]*([a-zA-Z0-9_"]+)[\t ]+[0-9a-zA-Z()]+',onlyColumnDDL,re.I|re.M);
    for match in findColumns:
        columnName = match.group(1);
        if columnName.upper() in keyWords:
            columnName_n = '`'+columnName+'`';
            onlyColumnDDL = onlyColumnDDL.replace(columnName,columnName_n);
    srcStr = srcStr.replace(onlyColumnDDL_ori,onlyColumnDDL); 
    return srcStr;

#剔除hash分布键中不支持的类型
def kickoffNotSupportDistributedKeyType(srcStr):
    columnDic = {}; #存储每个带有distributed的ddl的所有列名和类型的字典
    distriKeys = [];
    supportType = {'varchar','tinyint','smallint','bigint','decimal','NUMERIC'};
    #获取带有分布键的表结构 
    withDistributedDDL = re.finditer('create[\s]+table[\s]+[\S]+[\s]*\(([\s\S]+?)[\s]*\)[\s]*(distributed[\s]+by[\s]*\()([\s\S]+?)(\)[\s\S]*?;)',srcStr,re.I|re.M);
    for match in withDistributedDDL:
        oldDistris = match.group(2)+match.group(3)+match.group(4)
        #第一列
        column1 = re.finditer('\([\s]*([a-zA-Z0-9_"]+)[\t ]+([0-9a-zA-Z]+)',srcStr,re.I|re.M);
        for col1 in column1:
            columnDic[col1.group(1).strip('"').lower()] = col1.group(2);
        #表除了第一列外的其他列
        column = re.finditer(',[\s]*(["a-zA-Z0-9()_]+)[\t ]+([a-zA-Z0-9]+)',srcStr,re.I|re.M);
        for col in column:
            columnDic[col.group(1).strip('"').lower()] = col.group(2);
            
        distriCols = match.group(3).strip("'").lower();
        distriCols = distriCols.replace("'",'');
        distriKeys = distriCols.split(',');
        for key in distriKeys[::-1]:
            print key
            colType = columnDic[key];
            if colType not in supportType:
                distriKeys.remove(key)        
        
        if len(distriKeys) > 0:      
            newDisKey = " DISTRIBUTED BY('";        
            for kn in distriKeys:
                newDisKey = newDisKey + kn + "','";
            newDisKey = newDisKey + "'";
            newDisKey = newDisKey.replace(",''","");
            srcStr = srcStr.replace(oldDistris,newDisKey + match.group(4));
        else:
            srcStr = srcStr.replace(oldDistris, match.group(4).strip(')'));
    return srcStr;
                  
'''
替换ddl中oracle的语法
'''
def commonReplace(sourceStr):
    sourceStr=re.sub('[\s]varchar2[\s]*\(',' varchar(',sourceStr,0,re.I|re.M); #varchar2-->varchar
    sourceStr=re.sub('[\s]\\bnumber\\b([\s]*[\(,]?)',' decimal\\1',sourceStr,0,re.I|re.M); #number-->decimal
    sourceStr=re.sub('[\s]+segment[\s\S]*?;',';',sourceStr,0,re.I|re.M); #delete contents between segment and ;
    sourceStr=re.sub('([\s]+)date([\s]*[,)])','\\1datetime\\2',sourceStr,0,re.I|re.M); #date-->datetime
    sourceStr=re.sub('[\s]+char[\s]*\)',')',sourceStr,0,re.I|re.M); #date-->datetime
    sourceStr=re.sub('\*','38',sourceStr,0,re.I|re.M); #number(*,1)-->decimal(38,1)
    sourceStr=re.sub('[\s]\\benable\\b','',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('WITH[\s]+DEFAULT','DEFAULT',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('timestamp[\s]*\([\s]*[0-9]+[\s]*\)','datetime',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bint1\\b[\s]+','`int1` ',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bint2\\b[\s]+','`int2` ',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bcharacter\\b[\s]+','`character` ',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bCLOB\\b','LONGTEXT',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bLIMIT\\b','`LIMIT`',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bdescribe\\b','`describe`',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bas\\b[\s]+\(.*\)','VARCHAR(16)',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bnvarchar2\(([0-9]+)\)','VARCHAR(\\1)',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('default[\s]+sysdate','',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('default[\s]+TO_CHAR\([\s]*SYSDATE[\s]*,[\s]*\'YYYYMMDD\'[\s]*\)','',sourceStr,0,re.I|re.M);  
    sourceStr=re.sub('default[\s]+SYS_GUID\(\)','',sourceStr,0,re.I|re.M);
    sourceStr=re.sub("TO_CHAR\([\s]*SYSDATE[\s]*,[\s]*'[\s]*yyyymmddhhmiss[\s]*'\)",'',sourceStr,0,re.I|re.M);  
    sourceStr=re.sub('([0-9]+)[\t ]+char[\s]*\)','\\1)',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('\\bnumber\\b','DECIMAL',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('([0-9]+)[\s]+BYTE','\\1',sourceStr,0,re.I|re.M);
    sourceStr=re.sub('default[\s]+to_number\(.*\)','',sourceStr,0,re.I|re.M);
    
        
    return sourceStr;

'''
使用oracle的最后的index的第一个列作为分布键
'''
def distributedKey(sourceStr):
    keyName="";
    indexContents=re.finditer("CREATE[\s]+INDEX[\s]+[\S]+[\s]+ON[\s]+[\S]+[\s]*\([\s]*\"[\s]*([\S]+)[\s]*\"",sourceStr,re.I|re.M);
    for match in indexContents:
        keyName = match.group(1).strip();
        keyName = keyName.replace('"','');
    if keyName!="":
        returnVal = " DISTRIBUTED BY('" + keyName.strip(',') + "')";
        returnVal = returnVal.replace(",","','");
        return returnVal;
    else:
        primayk=re.finditer("primary[\s]+key[\s]*\([\s]*([\S]+)[\s]*[,]?",sourceStr,re.I|re.M);
        for pkey in primayk:
            keyName=pkey.group(1).strip().strip(')');
            if keyName!="":
                returnVal = " DISTRIBUTED BY('" + keyName.strip(',') + "')";
                returnVal = returnVal.replace(",","','");
                return returnVal;
    return "";
    
'''
获取表的注释
'''        
def getTableComment(tableName,sourceStr):
    #sourceStr = re.sub('"','',sourceStr,0,re.I|re.M);
    tableComment=re.finditer("comment[\s]+on[\s]+table[\s]+([\S]+)[\s]+is[\s]+([\s\S]*?'[\s]*);",sourceStr,re.I|re.M);
    for comment in tableComment:
        if comment.group(1)==tableName.replace('"',''):
            return " COMMENT "+comment.group(2);
        else:
            return "";
    return "";

'''
获取列的注释
'''
def getColumnComment(tableName,columnName,sourceStr):
    dntncn=tableName.replace('"','')+'.'+columnName.strip(')').strip('(')
    restr="comment[\s]+on[\s]+column[\s]+"+dntncn.replace('.','\.')+"[\s]+is[\s]+([\s\S]*?'[\s]*);"
    sourceStr = re.sub('"','',sourceStr,0,re.I|re.M);
    columnComment=re.finditer(restr,sourceStr,re.I|re.M)
    for comment in columnComment:
        #print comment.group(1)
        return " COMMENT "+comment.group(1)
    return ""

def convertTooLongChar(sourceStr):
    charContents = re.finditer("[\s]+char[\s]*\([\s]*([0-9]+)[\s]*\)",sourceStr,re.I|re.M);
    for match in charContents:
        if int(match.group(1)) > 255:
            sourceStr = sourceStr.replace(match.group(),' varchar('+match.group(1)+')')
    return sourceStr

    
'''
主程序
'''                   
for filename in glob.glob(inputpath):
    with open(filename,'r') as f:
        elementsCount=0;
        currentCount=0;
        with open(outputpath+'/'+filename.split('/')[-1]+'_gbase','w+') as fout:
            contents=f.read().rstrip(); #read file content and remove extra spaces
            contents=re.sub('  ',' ',contents,0,re.I|re.M);  #replace 2space to 1space
            contents=re.sub('\t',' ',contents,0,re.I|re.M);
            contents=re.sub('\r\n','\n',contents,0,re.I|re.M);
            contents=re.sub('"[\s]*([\S]+)[\s]*"','"\\1"',contents,0,re.I|re.M);
            count=re.finditer(r'create[\s]+table[\s]+',contents.lower(),re.I|re.M);
            for match in count:
                elementsCount=elementsCount+1;

            print "\n\033[0;30;41mConverting: "+filename+"\033[0m";

            #Replace "--" to "-- "
            contents=re.sub('(--)(.*)$','\\1 \\2',contents,0,re.I|re.M); #re.I case not sensitive; re.M is multiline match
            tableddl="";
            
            #获取每个DDL的代码块
            oneDDLSection=re.finditer('^[\s]*create[\s]+table[\s]+([\S]+)[\s]+[\s\S]+?;',contents,re.I|re.M);
            for match in oneDDLSection:
                DDLContents=match.group();
                #print DDLContents
                finalDDL="";
                currentCount=currentCount+1;
                splitColumn=getFunContent(DDLContents,'create[\s]+table[\s]+[\S]+[\s]*',0).split('\n');
                for i in range(len(splitColumn)):
                    if splitColumn[i].strip() != '':
                        columnName=splitColumn[i].split()[0].strip('"').strip(); #不带引号的列名称
                        if ("," in splitColumn[i].upper())==True:
                            if(getColumnComment(match.group(1),columnName,DDLContents)!=""):
                                finalDDL=finalDDL+splitColumn[i].strip().strip('\n').strip(',')+str(getColumnComment(match.group(1),columnName,DDLContents))+",\n";
                            else:
                                finalDDL=finalDDL+splitColumn[i].strip()+"\n";
                        else:
                            finalDDL=finalDDL+splitColumn[i].strip()+str(getColumnComment(match.group(1),columnName,DDLContents))+"\n";
       
                finalDDL=finalDDL.strip('\n').strip(',');
                finalDDL=commonReplace(finalDDL); #对常见的语法差异进行替换
                finalDDL=finalDDL+distributedKey(DDLContents); #加上分布键，采用的是oracle的最后的一个index中的第一个列作为分布键
                finalDDL=finalDDL+str(getTableComment(match.group(1),DDLContents))+";\n\n"; #加上表的注释
                
                finalDDL=convertTooLongChar(finalDDL) 
                finalDDL = re.sub('(comment[\s]+.*),([\s]+\))','\\1\\2',finalDDL,0,re.I|re.M);  
                finalDDL = addEncloseToKeywordColumn(finalDDL);
                finalDDL = kickoffNotSupportDistributedKeyType(finalDDL);
                finalDDL=re.sub('"`','"',finalDDL,0,re.I|re.M);
                finalDDL=re.sub('`"','"',finalDDL,0,re.I|re.M);
                
                
                #打印处理进度
                print '\r'+"Total:"+str(elementsCount)+"  "+"Current:"+str(float('%.3f'%(float(currentCount+1)/elementsCount))*100)+"%",
                sys.stdout.flush();
                fout.write(finalDDL);
                
