#!/usr/bin/python
#-*- coding:utf-8 –*-

import re #regular expression
import os
import sys
import glob
import StringIO
import itertools 
#from GBaseConnector import connect,GBaseError

#The params of gbase 8a connect
#config = {'host':'192.168.222.133','port':5258,'database':'test','user':'gbase','passwd':'gbase20110531','use_unicode':False};

def addCommentToTable(tableName,columnName,commentContent):
    try:
        conn = connect() 
        conn.connect(**config) 
        cur = conn.cursor()
        if re.search('\.',tableName):
            schemaName = tableName.split('.')[0]
            tableN = tableName.split('.')[1]
        else:
            tableN = tableName.split('.')[0]
            cur.execute("select database();");
            dbname = cur.fetchall()
            for col in range(len(dbname)):
                schemaName=dbname[col][0].strip(',');
        cur.execute("select column_name,column_type from information_schema.columns where table_schema='" + schemaName + "' and table_name='" + tableN + "'")
        columns = cur.fetchall()
        for col in range(len(columns)):
            column=str(columns).split("),")[col].strip("[").strip("]").strip(")").strip(" (").replace("', '"," ").replace("'","").split(' ')[0].strip();
            if columnName==column:
                return "alter table "+tableName+" modify "+str(columns).split("),")[col].strip("[").strip("]").strip(")").strip(" (").replace("', '"," ").replace("'","")+" comment "+commentContent;
    except GBaseError.DatabaseError, err: 
        print err 
    finally:
        conn.close() 
        
def getSubQuery(sourceStr):
    returnContents="";
    subQs=re.finditer('\([\s]*select',sourceStr,re.I|re.M);
    for match in subQs:
        startPos=match.span()[0];
        leftParenthesesCnt=1;
        loopCnt=0;
        while True:
            if sourceStr[loopCnt+startPos]=='(':
                leftParenthesesCnt=leftParenthesesCnt+1;
                if leftParenthesesCnt==1:
                    break;
            elif sourceStr[loopCnt+startPos]==')':
                leftParenthesesCnt=leftParenthesesCnt-1;
                if leftParenthesesCnt==1:
                    break;
            loopCnt=loopCnt+1;
        returnContents=returnContents+sourceStr[startPos:startPos+loopCnt+1]+'\n&';
    return returnContents.rstrip('&\n');
    
def getFunContent(sourceStr,funcName):
    returnContents="";
    funcCotents=re.finditer("\\b"+funcName+"\\b",sourceStr,re.I|re.M);
    for match in funcCotents:
        startPos=match.span()[0]+len(funcName);
        leftParenthesesCnt=1;
        loopCnt=0;
        while True:
            if sourceStr[loopCnt+startPos]=='(':
                leftParenthesesCnt=leftParenthesesCnt+1;
                if leftParenthesesCnt==1:
                    break;
            elif sourceStr[loopCnt+startPos]==')':
                leftParenthesesCnt=leftParenthesesCnt-1;
                if leftParenthesesCnt==1:
                    break;
            loopCnt=loopCnt+1;
        returnContents=returnContents+sourceStr[startPos:startPos+loopCnt+1]+'&\n';      
    return returnContents.rstrip('&\n');
    
'''
转换存储过程中create语句,替换create or replace,修改in、out的参数位置，添加delimiter，drop procedure语句
'''
def convertCreateProc(dbtype,contents):
    returnVal = ""
    params = ""
    procName = ""
    if dbtype == 'oracle':
        varDefineContents = re.finditer('^[\s]*create.*?procedure[\s]+([\S]+)[\s]*\(([\s\S]*?)\)[\s\S]*?\\b[ias]{2}\\b[\s\S]*?begin',contents,re.I|re.M)
        for match in varDefineContents:
            procName = match.group(1).strip('\n')
            paramLists = match.group(2).strip('\n').split(',')
            for param in range(len(paramLists)):
                paramin = ""
                paramout = ""
                if ' in ' in paramLists[param].strip().lower():
                    paramin = re.sub('[\s]+in[\s]+',' ',paramLists[param].strip(),0,re.I|re.M)
                    paramin = 'IN ' + paramin + ','
                elif ' out ' in paramLists[param].strip().lower():
                    paramout = re.sub('[\s]+out[\s]+',' ',paramLists[param].strip(),0,re.I|re.M)
                    paramout = 'OUT ' + paramout + ','
                else:
                    paramin = re.sub('[\s]+in[\s]+',' ',paramLists[param].strip(),0,re.I|re.M)
                    paramin = 'IN ' + paramin + ','
                    
                params =  params + paramin + paramout
                params = re.sub('varchar2','VARCHAR',params,0,re.I|re.M)

    returnVal = "DELIMITER //\nDROP PROCEDURE IF EXISTS " + procName + " //\nCREATE PROCEDURE " + procName + "(" + params.strip(',') + ")\nBEGIN\n"
    return returnVal

'''
转换存储过程中的变量定义,对于:=的模式赋初值，改为set,default方式默认值保持不变
'''
def convertVarDefine(dbtype,contents):
    returnVal = ""
    needsetvar = ""
    if dbtype == 'oracle':
        varDefineContents = re.finditer('create.*procedure[\s\S]*?\\b[ias]{2}\\b([\s\S]*?)begin',contents,re.I|re.M)
        for match in varDefineContents:
            returnVal = match.group(1).strip('\n')
            allvars = re.finditer('^[\t ]*[a-zA-Z0-9_]+.*;',returnVal,re.I|re.M)
            for var in allvars:
                oldc = var.group()
                newc = 'DECLARE '+oldc.strip().split(':=')[0].strip(';')
                newc = re.sub('varchar2','VARCHAR',newc,0,re.I|re.M)
                newc = re.sub('([0-9]+)[\s]+char','\\1',newc,0,re.I|re.M)
                newc = re.sub('[\s]+',' ',newc,0,re.I|re.M)
                newc = re.sub('[\s]+number',' DECIMAL',newc,0,re.I|re.M)
                newc = newc.strip() + ';' 
                returnVal = returnVal.replace(oldc,newc)
                if ':=' in oldc: #判断是否有:=格式默认值，如果有则转换到set
                    needsetvar = needsetvar + 'SET '+var.group().strip().split(' ')[0].split('\t')[0] + ' = ' + var.group().strip().split(':=')[1].strip() + '\n' 
        returnVal= returnVal + '\n' + "DECLARE TMPEXCEPTIONCONTENTS VARCHAR(1000);" + needsetvar.strip()          
        return returnVal

'''
转换变量赋值，转换范围是单个存储过程的begin与end存储过程段
'''
def convertAssignment(dbtype,contents):
    if dbtype == 'oracle':
        assignmentContents = re.finditer('(^.*):=(.*;)',contents,re.I|re.M)
        for match in assignmentContents:
            oldAssignment = match.group()
            if '--' not in oldAssignment:
                newAssignment = "set " + match.group(1) + " = " + match.group(2)
                contents = contents.replace(oldAssignment,newAssignment)
    return contents

'''
转换EXECUTE IMMEDIATE
'''
def convertExecuteImmediate(dbtype,contents):
    if dbtype == 'oracle':
        contents = re.sub("EXECUTE[\s]+IMMEDIATE.*force[\s]+parallel.*;[\s]*","",contents,0,re.I|re.M)
        contents=re.sub("EXECUTE[\s]+IMMEDIATE[\s]+'alter[\s]+session[\s\S]*?;","",contents,0,re.I|re.M);
        executeImmContents = re.finditer('EXECUTE[\s]+IMMEDIATE([\s\S]*?;)',contents,re.I|re.M)
        for match in executeImmContents:
            #print match.group(1).strip('\n')
            executecontent = match.group(1).strip('\n')
            executecontent = re.sub("[\s]*'[\s]*DROP[\s]+STORAGE[\s]*'","''",executecontent,0,re.I|re.M)
            
            returnVal = "set @SQL = " + executecontent + "\nprepare stmt from @SQL;\nexecute stmt;\n"
            contents = contents.replace(match.group(),returnVal)
    return contents

'''
转换exception内容
''' 
def convertException(dbtype,contents):
    exceptionContents = re.finditer('EXCEPTION[\s]+WHEN[\s]+OTHERS[\s]+THEN([\s\S]*)',contents,re.I|re.M)
    for match in exceptionContents:
        newexception = re.sub('RAISE_APPLICATION_ERROR[\s\S]*?;','',match.group(1).strip(),0,re.I|re.M);        
        contents = contents.replace(match.group(),'') #清除原有的exception内容
        newexception = "declare SQLERRM VARCHAR(300);\ndeclare exit handler for sqlexception\nbegin\nget diagnostics condition 1  SQLERRM = message_text;\n" + newexception.strip() + "\nselect Vc_MSG;\nend;\n"
        contents = contents.replace("DECLARE TMPEXCEPTIONCONTENTS VARCHAR(1000);",newexception.strip())
    return contents

def specialConvert(contents):
    ori_strlistagg = '''SELECT DISTINCT LN_ACCTNO, LISTAGG(REPAY_ACCTNO,',') WITHIN GROUP (ORDER BY REPAY_ACCTNO)OVER(PARTITION BY LN_ACCTNO) AS REPAY_ACCTNO FROM (
     SELECT DISTINCT LN_ACCTNO,REPAY_ACCTNO
         FROM EDW_ETL.TMP_STDNT_LN_INFO02 TMP2 )'''
    new_str = '''select distinct ff.LN_ACCTNO,tt.REPAY_ACCTNO from 		 
(select LN_ACCTNO,group_concat(REPAY_ACCTNO) REPAY_ACCTNO from (
     SELECT DISTINCT LN_ACCTNO,REPAY_ACCTNO
         FROM EDW_ETL.TMP_STDNT_LN_INFO02 TMP2 ) KK group by LN_ACCTNO) TT
join
(select LN_ACCTNO from (
     SELECT DISTINCT LN_ACCTNO,REPAY_ACCTNO
         FROM EDW_ETL.TMP_STDNT_LN_INFO02 TMP2 ) KK) FF
on tt.LN_ACCTNO = ff.LN_ACCTNO'''
    
    str1_re = "delete from ODS_RDM.HS_BSNS_LN_DTL where EDW_DATA_DT = date(PI_WORKDATE);"
    contents = contents.replace(ori_strlistagg,new_str)
    return contents

'''
入参日期做日期运算的替换
'''
def dateVarOperationConvert(sourceContents):
    sourceContents = re.sub("\\bVD_DT\\b","date(VD_DT)",sourceContents,0,re.I|re.M)
    sourceContents = re.sub("declare[\s]+date\(VD_DT\)","declare VD_DT",sourceContents,0,re.I|re.M)
    sourceContents = re.sub("set[\s]+date\(VD_DT\)","set VD_DT",sourceContents,0,re.I|re.M)
    return sourceContents    
        
inputpath = sys.argv[1] + '/*'; #must input physical path
outputpath = sys.argv[2]; # must input physical path

for filename in glob.glob(inputpath):
    with open(filename,'r') as f:
        with open(outputpath+'/'+filename.split('/')[-1]+'_gbase','w+') as fout:
            contents=f.read().rstrip(); #read file content and remove extra spaces
            contents=re.sub('  ',' ',contents,0,re.I|re.M);  #把两个空格换成一个空格
            contents=re.sub('\t',' ',contents,0,re.I|re.M); #把制表符换成空格
            contents=re.sub('\r\n','\n',contents,0,re.I|re.M);
            #contents=re.sub('\([\s]*any[\s]*\)','(16)',contents,0,re.I|re.M); #转换(ANY)为(10)
            #contents=re.sub('[\s]+chr[\s]*\(',' CHAR\(',contents,0,re.I|re.M); #转换chr到char
            contents=re.sub('\\brownum\\b','row_number() over(order by 1)',contents,0,re.I|re.M);
            contents=re.sub('([\S]+\.SP_CM_GEN_LOG.*)','-- \\1',contents,0,re.I|re.M); #转换chr到char
            contents=re.sub('\\bsubstrb\\b','substr',contents,0,re.I|re.M);
            contents=re.sub('\\bsysdate\\b','now()',contents,0,re.I|re.M);
            contents=re.sub('REUSE[\s]+STORAGE','',contents,0,re.I|re.M);
            contents=re.sub('\\bNOLOGGING\\b','',contents,0,re.I|re.M);
            contents=re.sub('\\bELSIF\\b','ELSEIF',contents,0,re.I|re.M);
            contents=re.sub('\\bEDITIONABLE\\b','',contents,0,re.I|re.M); 
            contents=re.sub('\\bnumber\\b','decimal',contents,0,re.I|re.M);            
            allProcCount=0;
            currentPorcIndex=1;
            
            #获取proc的总数
            findProc = re.finditer('create.*procedure[\s]+([\S]+)[\s]*\(([\s\S]*?\)[\s\S]*?)begin([\s\S]*?)end[\s]*;',contents,re.I|re.M);
            for match in findProc:
                allProcCount=allProcCount+1;
                
            #处理raise notice
            raiseContents=re.finditer('raise[\s]+notice[\s]+[\s\S]*?;',contents,re.I|re.M);
            for match in raiseContents:
                oldRaiseContent=match.group().split('(')[0];
                #print oldRaiseContent;
                newRaiseContent=re.sub('raise[\s]+notice[\s]+','SELECT ',oldRaiseContent,0,re.I|re.M);
                newRaiseContent=newRaiseContent.replace('%','').replace(',','||').split('(')[0];
                #print newRaiseContent;
                contents=re.sub(oldRaiseContent,newRaiseContent,contents,0,re.I|re.M); 
            
            #替换到--注释
            contents=re.sub('(--)(.*)$','\\1 \\2',contents,0,re.I|re.M); #re.I case not sensitive; re.M is multiline match
            contents=re.sub('[\s]+timestamp',' datetime',contents,0,re.I|re.M); #替换timestamp到datetime
 
            print "\nConverting fileName: "+ filename;

            #在一个存储过程文件中获取一个存储过程片段
            allContentsOfOneProc="";
            oneProcSection = re.finditer('create.*procedure[\s]+([\S]+)[\s]*\(([\s\S]*?\)[\s\S]*?)begin([\s\S]*?)end[\s]*;',contents,re.I|re.M);
            for match in oneProcSection:
                beginendContents = "";
                print "\r"+"Converting:"+ filename+"\tTotal Proc:" +str(allProcCount)+"\tCurrent Proc: "+ str(currentPorcIndex)+"\n",
                sys.stdout.flush();
                allContentsOfOneProc=match.group(0);
                beginendContents = match.group(3)
                afterConvertContent=convertCreateProc('oracle',allContentsOfOneProc)
                afterConvertContent = afterConvertContent + convertVarDefine('oracle',allContentsOfOneProc)
                beginendContents = convertAssignment('oracle',beginendContents)
                beginendContents = convertExecuteImmediate('oracle',beginendContents)
                
                afterConvertContent = afterConvertContent + beginendContents
                afterConvertContent = convertException('oracle',afterConvertContent)
                afterConvertContent = afterConvertContent + "END //\ndelimiter ;\n"

                afterConvertContent = re.sub('DBMS_OUTPUT.PUT_LINE[\s\S]*?;','',afterConvertContent,0,re.I|re.M);
                afterConvertContent = dateVarOperationConvert(afterConvertContent) 
                afterConvertContent = re.sub('([\S]+[\s]*):=','set \\1=',afterConvertContent,0,re.I|re.M);
                afterConvertContent = specialConvert(afterConvertContent);

                fout.write(afterConvertContent+"\n"); 
                currentPorcIndex =currentPorcIndex+1
                