#!/usr/bin/python
#-*- coding:utf-8 -*-

import re #regular expression
import os
import sys
import glob
import StringIO
import itertools

def removeNotSupportDisKey(key,ddlContent):
    keyType = re.finditer(key+"[\s]+([\S]+)",ddlContent,re.I|re.M);
    for match in keyType:
        if (not re.search(',',match.group(1),re.I|re.M) and not re.search('\)[\s]*;',match.group(1),re.I|re.M)) and match.group(1) != ')':
            if (re.search('date',match.group(1),re.I|re.M) or re.search('time',match.group(1),re.I|re.M)):
                ddlContent = re.sub("'" + key + "'",'',ddlContent,0,re.I|re.M);
                dlContent = re.sub(",[\s]*,",',',ddlContent,0,re.I|re.M);
                ddlContent = re.sub("\([\s]*,",'(',ddlContent,0,re.I|re.M);
                ddlContent = re.sub(",[\s]*\)",')',ddlContent,0,re.I|re.M);
                ddlContent = re.sub("distributed[\s]+by[\s]*\([\s]*\)",' replicated',ddlContent,0,re.I|re.M);
    return ddlContent;

def convertDDL(ddlContent):
    ddlContent = re.sub('[,]?[\s]*CHECKSUM[\s]*=[\s]*DEFAULT[\s]*[,]?','',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*NO[\s]*AFTER[\s]*JOURNAL[\s]*[,]?',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*NO[\s]*BEFORE[\s]*JOURNAL[\s]*[,]?',' ',ddlContent,0,re.I|re.M); 
    ddlContent = re.sub('[,]?[\s]*FALLBACK[\s]*[,]?',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*NO[\s]*LOG[\s]*[,]?',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[\s]*VOLATILE[\s]*MULTISET[\s]*',' TEMPORARY ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[\s]*MULTISET[\s]*VOLATILE[\s]*',' TEMPORARY ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[\s]*CHARACTER[\s]+SET[\s]+LATIN[\s]+NOT[\s]+CASESPECIFIC[\s]*',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[\s]*CHARACTER[\s]+SET[\s]+LATIN[\s]+CASESPECIFIC[\s]*',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[\s]+TITLE[\s]+',' COMMENT ',ddlContent,0,re.I|re.M); 
    ddlContent = re.sub('[\s]+SET[\s]+',' ',ddlContent,0,re.I|re.M);    
    ddlContent = re.sub('[\s]+MULTISET[\s]+',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('on[\s]+commit[\s]+preserve[\s]+rows[\\\]?[\s]?',"",ddlContent,0,re.I|re.M);
    ddlContent = re.sub('UNIQUE[\s]+',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*NO[\s]+JOURNAL[\s]*[,]?',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*FREESPACE[\s]*=[\s]*[0-9]+[\s]+PERCENT[\s]*[,]?',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*DATABLOCKSIZE[\s]*=[\s]*[0-9]+[\s]+BYIES[\s]*[,]?',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('CURRENT_TIMESTAMP(0)','CURRENT_TIMESTAMP()',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('--','-- ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*NO[\s]+[\s]*[,]?',' ',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('FORMAT[\s]+[\S]+','',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('TIME\([\s]*[0-9]+[\s]*\)','TIME',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('[,]?[\s]*DEFAULT[\s]+MERGEBLOCKRATIO[\s]*[,]?','TIME',ddlContent,0,re.I|re.M);
    ddlContent = re.sub('PARTITION[\s]+by[\s\S]*;',';',ddlContent,0,re.I|re.M);
    #转换分布键
    priIndex = re.finditer('PRIMARY[\s]+INDEX[\s]*\(([\s\S]*?)\)',ddlContent,re.I|re.M); 
    for match in priIndex:
        keys = match.group(1).strip();
        keys = keys.replace(",","','");
        keys = keys.replace(" ","");
        keys = keys.replace("\t","");
        ddlContent = re.sub("PRIMARY[\s]+INDEX[\s]*\(([\s\S]*?)\)","DISTRIBUTED BY('" + keys + "')",ddlContent,0,re.I|re.M);
        #剔除不支持的分布键
        for keyIdx in range(len(keys.split(','))):
            ddlContent = removeNotSupportDisKey(keys.split(',')[keyIdx].strip("'"),ddlContent);        
    return ddlContent;

inputpath = sys.argv[1] + '/*';
outputpath = sys.argv[2];

for filename in glob.glob(inputpath):
    with open(filename,'r') as f:
        with open(outputpath+'/'+filename.split('/')[-1]+'_gbase','w+') as fout:
            writeBuf = "";
            contents = f.read();
            tableDDLfd = re.finditer('\\bcreate\\b([\s\S](?!\\bcreate\\b))*;',contents,re.I|re.M);
            for match in tableDDLfd:
                ddlContents = match.group();
                writeBuf += convertDDL(ddlContents);
            fout.write(writeBuf + "\n");