#!/usr/bin/python
#-*- coding:utf-8 –*-

#使用方式：
#新建一个目录，把原始的ddl放到这个目录,比如ori
#新建另外一个目录，用来存入转换后的ddl,比如gba
#命令：python ntzddl2gb.py ori gba

import re #regular expression
import os
import sys
import glob
import itertools
from GBaseConnector import connect,GBaseError
#The params of gbase 8a connect
config = {'host':'192.168.222.133','port':5258,'database':'test','user':'gbase','passwd':'gbase20110531','use_unicode':False}

inputpath = sys.argv[1] + '/*'; 
outputpath = sys.argv[2]; 

keyWords={'ACCESSIBLE','ADD','ALL','ALTER','ANALYZE','AND','AS','ASC','ASENSITIVE','BEFORE','BETWEEN','BIGINT','BINARY','BLOB','BOTH','BY','CALL','CASCADE','CASE','CHANGE','CHAR','CHARACTER','CLUSTER','COLLATE','COLUMN','COMPRESS','CONDITION','CONNECT','CONSTRAINT','CONTINUE','CONVERT','CREATE','CROSS','CURRENT_DATE','CURRENT_DATETIME','CURRENT_TIME','CURRENT_TIMESTAMP','CURRENT_USER','CURSOR','DATABASE','DATABASES','DAY_HOUR','DAY_MICROSECOND','DAY_MINUTE','DAY_SECOND','DEC','DECIMAL','DECLARE','DEFAULT','DELAYED','DELETE','DESC','DESCRIBE','DETERMINISTIC','DISTINCT','DISTINCTROW','DISTRIBUTE','DISTRIBUTED','DIV','DOUBLE','DROP','DUAL','EACH','ELSE','ELSEIF','ENCLOSED','ESCAPED','EXISTS','EXIT','EXPLAIN','EXCEPT','FALSE','FETCH','FLOAT','FLOAT4','FLOAT8','FOR','FORCE','FOREIGN','FROM','FULL','FULLTEXT','GCEXPORT','GCIMPORT','GCLOCAL','GCLUSTER','GCLUSTER_LOCAL','GET','GRANT','GROUP','GROUPED','HAVING','HIGH_PRIORITY','HOUR_MICROSECOND','HOUR_MINUTE','HOUR_SECOND','IF','IGNORE','IN','INDEX','INFILE','INITNODEDATAMAP','INNER','INOUT','INSENSITIVE','INSERT','INT','INT1','INT2','INT3','INT4','INT8','INTEGER','INTERSECT','INTERVAL','INTO','IS','ITERATE','JOIN','KEY','KEYS','KILL','LEADING','LEAVE','LEFT','LEVEL','LIKE','LIMIT','LIMIT_STORAGE_SIZE','LINEAR','LINES','LINK','LOAD','LOCALTIME','LOCALTIMESTAMP','LOCK','LONG','LONGBLOB','LONGTEXT','LOOP','LOW_PRIORITY','MATCH','MEDIUMBLOB','MEDIUMINT','MEDIUMTEXT','MERGE','MIDDLEINT','MINUS','MINUTE_SECOND','MOD','MODIFIES','NATURAL','NOCOPIES','NOCYCLE','NULL','NUMERIC','ON','OPTIMIZE','OPTION','OPTIONALLY','OR','ORDER','ORDERED','OUT','OUTER','OUTFILE','OVER','PRIMARY','PRIOR','PROCEDURE','PURGE','RANGE','READ','READS','READ_WRITE','REAL','REFERENCES','REFRESH','REGEXP','RELEASE','RENAME','REPEAT','REPLACE','REQUIRE','RESTRICT','RETURN','REVERT','REVOKE','RIGHT','RLIKE','SCHEMA','SCHEMAS','SCN_NUMBER','SECOND_MICROSECOND','SELECT','SELF','SENSITIVE','SEPARATOR','SET','SHOW','SMALLINT','SORT','SPATIAL','SPECIFIC','SQL','SQLEXCEPTION','SQLSTATE','SQLWARNING','SQL_BIG_RESULT','SQL_SMALL_RESULT','SSL','START','STARTING','STRAIGHT_JOIN','TABLE','TARGET','TERMINATED','THEN','TINYBLOB','TINYINT','TINYTEXT','TO','TRAILING','TRIGGER','TRUE','UNDO','UNION','UNIQUE','UNLOCK','UNSIGNED','UPDATE','USAGE','USE','USING','UTC_DATE','UTC_DATETIME','UTC_TIME','UTC_TIMESTAMP','VALUES','VARBINARY','VARCHAR','VARCHARACTER','VARYING','WHEN','WHERE','WHILE','WITH','WRITE','XOR','YEAR_MONTH','ZEROFILL','LEVEL'};

def addCommentToTable(tableName,columnName,commentContent):
    try:
        conn = connect() 
        conn.connect(**config) 
        cur = conn.cursor()
        if re.search('\.',tableName):
            schemaName = tableName.split('.')[0]
            tableN = tableName.split('.')[1]
        else:
            tableN = tableName.split('.')[0]
            cur.execute("select database();");
            dbname = cur.fetchall()
            for col in range(len(dbname)):
                schemaName=dbname[col][0].strip(',');
        cur.execute("select column_name,column_type from information_schema.columns where table_schema='" + schemaName + "' and table_name='" + tableN + "'")
        columns = cur.fetchall()
        for col in range(len(columns)):
            column=str(columns).split("),")[col].strip("[").strip("]").strip(")").strip(" (").replace("', '"," ").replace("'","").split(' ')[0].strip();
            if columnName==column:
                return "alter table "+tableName+" modify "+str(columns).split("),")[col].strip("[").strip("]").strip(")").strip(" (").replace("', '"," ").replace("'","")+" comment "+commentContent;
    except GBaseError.DatabaseError, err: 
        print err 
    finally:
        conn.close()

for filename in glob.glob(inputpath):
    with open(filename,'r') as f:
        elementsCount=0;
        currentCount=0;
        with open(outputpath+'/'+filename.split('/')[-1]+'_gbase','w+') as fout:
            contents=f.read().rstrip(); #read file content and remove extra spaces
            contents=re.sub('  ',' ',contents,0,re.I|re.M);  #replace 2space to 1space
            contents=re.sub('\t',' ',contents,0,re.I|re.M);
            contents=re.sub('\r\n','\n',contents,0,re.I|re.M);
            count=re.finditer(r'create[\s]+table[\s]+',contents.lower(),re.I|re.M);
            for match in count:
                elementsCount=elementsCount+1;

            print "\n\033[0;30;41mConverting: "+filename+"\033[0m";

            #Replace "--" to "-- "
            contents=re.sub('(--)(.*)$','\\1 \\2',contents,0,re.I|re.M); #re.I case not sensitive; re.M is multiline match
            tableddl="";
            
            #获取每个DDL的代码块
            oneDDLSection=re.finditer('create[\s]+table[\s]+([\w\W](?!create[\s]+table))*;',contents,re.I|re.M);
            for match in oneDDLSection:
                allcommentscontent="";
                columns="";
                currentCount=currentCount+1;
                DDLContents=match.group();
                searchResult=re.finditer('^[\s]*create[\s]+[\s\S]*?;',DDLContents,re.I|re.M);
                for match in searchResult:
                    searchResultStr=match.group();
                    tableddl=match.group(0); #get table ddl except comments content
                    tableddl=re.sub('byteint','smallint',tableddl,0,re.I|re.M); #replace byteint data type to smallint
                    tableddl=re.sub('timetz','varchar(16)',tableddl,0,re.I|re.M); #replace timetz datatype to varchar(16)
                    #print tableddl;
                    #处理distribute on 
                    newDistributColumns="";
                    oldDistributColumns="";
                    distributeContent=re.finditer('distribute[\s]+on[\s]+\(([\s\S]*?)\)[\s\S]*?;',DDLContents,re.I|re.M);
                    for match in distributeContent:
                        oldDistributColumns=match.group();
                        distributeColumns=match.group(1).split(',');
                        for i in range(len(distributeColumns)):
                            #print '\\b'+distributeColumns[i].strip()+'\\b.*';
                            #从表结构中找到字段对应的类型并做判断，剔除不支持的分布列类型
                            getDistributeColumnType=re.finditer('.*\\b'+distributeColumns[i].strip()+'\\b.*',searchResultStr,re.I|re.M);
                            for match in getDistributeColumnType:
                                if re.search('DISTRIBUTE|DATE|DATETIME|TIMESTAMP|CHARACTER\(|ORGANIZE',match.group().strip('\n'),re.IGNORECASE)==None: #剔除distribute 分布健行、不支持的分布类型的内容
                                    newDistributColumns=newDistributColumns+"'"+distributeColumns[i].strip()+"',";
                    if newDistributColumns!="":
                        newDistributColumns='DISTRIBUTED BY ('+newDistributColumns.strip(',')+');';
                    else:  
                        newDistributColumns="REPLICATED;";
                    if oldDistributColumns<>"":
                        tableddl=tableddl.replace(oldDistributColumns,newDistributColumns);
                               
                #get ddl's all columns name
                allcolumns=re.finditer('create[\s]+table[\s]+[\s\S]*?\(([\s\S]*)\)[\s]*distribute',DDLContents,re.I|re.M);
                for match in allcolumns:
                    #print match.group();
                    allColumnsCotent=match.group(1).strip();
                    columns=allColumnsCotent.split('\n');
                    for col in range(len(columns)):
                        column=columns[col].strip().split(' ')[0];
                        if column in keyWords:
                            tableddl=re.sub("^[\s]*\\b"+column+"\\b",'`'+column+'`',tableddl,0,re.I|re.M);
                
                #get table's comments
                tablecomment=re.finditer('comment[\s]+on[\s]+table[\s]+([\S]+)[\s]+is([\s\S]*?);[\s]*$',DDLContents,re.I|re.M);
                for match in tablecomment:
                    tablename=match.group(1);
                    commentcontent=match.group(2);    
                    # add table comment
                    tableddl=re.sub('(distribute[\s\S]*?);','\\1 COMMENT ' + commentcontent + ';',tableddl,0,re.I|re.M);
                
                #get all columns comments
                columnscomment=re.finditer('comment[\s]+on[\s]+column[\s]+([\S]+)[\s]+is[\s]+(.*);',DDLContents,re.I|re.M);
                for match in columnscomment:
                    columnnameincomment=match.group(1).split('.')[1];
                    columncomment=match.group(2);
                    i=-1;
                    for columnname in columns:
                        nodashnname=columnname.strip().split(' ')[0];
                        i=i+1;
                        if columnnameincomment==nodashnname:
                            if columns[i].strip('\n')[-1]==',':
                                newcontent=columns[i].strip('\n').rstrip(',')+' COMMENT ' + columncomment + ',';
                            else:
                                newcontent=columns[i].strip('\n').rstrip(',')+' COMMENT ' + columncomment;
                            tableddl=tableddl.replace(columns[i].strip('\n'),newcontent);
                            
                #print tableddl;
                #CHARACTER超长处理
                charTypeInfo=re.finditer('CHARACTER[\s]*\([\s]*([0-9]+)[\s]*\)',DDLContents,re.I|re.M);
                for match in charTypeInfo:
                    oldCharType=match.group();
                    if int(match.group(1))>255:
                        newCharType="CHARACTER VARYING("+match.group(1)+")";
                        tableddl=tableddl.replace(oldCharType,newCharType);
                #CHAR超长处理
                charTypeInfo=re.finditer('CHAR[\s]*\([\s]*([0-9]+)[\s]*\)',DDLContents,re.I|re.M);
                for match in charTypeInfo:
                    oldCharType=match.group();
                    if int(match.group(1))>255:
                        newCharType="NVRCHAR("+match.group(1)+")";
                        tableddl=tableddl.replace(oldCharType,newCharType);
                #print tableddl;                
                #add length to blank varying type
                j=0;
                for varycolumns in columns:
                    if re.search('varying',columns[j],re.IGNORECASE):
                        if re.search('varying[\s]*\(',columns[j],re.IGNORECASE)==None:
                            tableddl=tableddl.replace(columns[j].strip('\n'),columns[j].strip('\n')+'(64)');
                    j=j+1;
                allcommentscontent=allcommentscontent+tableddl+"\n\n";
                allcommentscontent=re.sub('distribute[\s]+on[\s]+RANDOM','replicated',allcommentscontent,0,re.I|re.M);
                allcommentscontent=re.sub("\"[\s]*timestamp[\s]*\"[\s]*\([\s]*\'now[\s]*\(.*\)[\s]*\'::[\s]*\".*\"[\s]*\)"," now()",allcommentscontent,0,re.I|re.M);
                allcommentscontent=re.sub("^[\s]*int[\s]+","\t`INT` ",allcommentscontent,0,re.I|re.M);
                allcommentscontent=re.sub("::\"NVARCHAR\"","",allcommentscontent,0,re.I|re.M);
                allcommentscontent=re.sub("::\"NUMERIC\"","",allcommentscontent,0,re.I|re.M);
                allcommentscontent=re.sub("[ ]timestamp([\s]*[,]?)"," datetime\\1",allcommentscontent,0,re.I|re.M);
                allcommentscontent=re.sub("[ ]timestamp([\s]+(comment|DEFAULT|NOT|NULL))"," datetime\\1",allcommentscontent,0,re.I|re.M);
                
                #打印处理进度
                print '\r'+"Total:"+str(elementsCount)+"  "+"Current:"+str(float('%.3f'%(float(currentCount)/elementsCount))*100)+"%",
                sys.stdout.flush();
                fout.write(allcommentscontent+'\n');
