#!/usr/bin/python
#-*- coding:utf-8 –*-

import re #regular expression
import os


#This function can returns the contents in pairs of parentheses
def matchlp(s):
        spos = [];
        rs = "";
        for i in range(0, len(s)):
                if(s[i] == '('):
                        spos.append(i);
                        continue;
                if(s[i] == ')' and spos):
                        ts = s[spos[-1]: i+1];
                        if(len(ts) > len(rs)):
                                rs = ts;
                        spos.pop();
        return rs;

#open file to be convert,input perl file and output perl file
with open('/data/perl/td_grammar.pl','r') as f:
	contents=f.read().rstrip(); #read file content and remove extra spaces
	contents=re.sub('\t\t','\t',contents,0,re.I|re.M); #replace 2tab to 1tab
	contents=re.sub('  ',' ',contents,0,re.I|re.M);  #replace 2space to 1space
	
	#Replace "--" to "-- "
	#2020-12-14 created by LYT
        #replace code:gb_repl_000000
	contents=re.sub('(--)(.*)$','\\1 \\2',contents,0,re.I|re.M); #re.I case not sensitive; re.M is multiline match

        #Replace "char" to "varchar"
        #2020-12-14 created by LYT
        #replace code:gb_repl_000000
	#remark:can not delete space before varchar string
        contents=re.sub('[\s]+char[\s]*\(',' varchar(',contents,0,re.I|re.M); 

	#replace bteq connect string to gbase
	#Ex. td:my $rc = open(BTEQ, "| bteq");
	#after replace:my $rc = open(BTEQ, "gccli -uroot -Dgbase -vvv ");
	#2020-12-14 created by LYT
	#replace code:gb_repl_000001
	#remark: test database name maybe not exists,can replace with others user database name, but can not use system database name
	contents=re.sub('(.[^\n]*"[\s]*)\|[\s]*bteq[\s]*(".[^\n]*)','\\1 | gccli -uroot -Dtest -vvv \\2',contents,0,re.I|re.M);

	#delete the contents start with "."
        #Ex. td:    .WIDTH 1024
        #after replace:-- .WIDTH 1024
        #2020-12-14 created by LYT
	#replace code:gb_repl_000002
	#remark:\\1 is first para of REG search,corresponding brackets included contents
	contents=re.sub('(^[ ]*\.[ ]*.*)','-- \\1',contents,0,re.I|re.M); 

	#delete LOGON string
	#Ex. td: line contents is "${LOGON_STR}"
	#atfter replace:-- ${LOGON_STR}
	#2020-12-14 created by LYT
	#replace code:gb_repl_000003
	contents=re.sub('^[\s]*(\${LOGON_STR}[\s]*$)','-- \\1',contents,0,re.I|re.M);

	#delete set variables contents
        #Ex. td:line "SET QUERY_BAND = 'JOB=$QRY_BAND;' FOR SESSION;"
        #atfter replace:-- SET QUERY_BAND = 'JOB=$QRY_BAND;' FOR SESSION;
        #2020-12-14 created by LYT
	#replace code:gb_repl_000004
        contents=re.sub('^[\s]*(set[\s]*.*$)','-- \\1',contents,0,re.I|re.M);

        #delete "with [no] data"
        #2020-12-15 created by LYT
        #replace code:gb_repl_000005
        contents=re.sub('(with.*data)','',contents,0,re.I|re.M);

        #delete "ON COMMIT PRESERVE ROWS"
        #2020-12-15 created by LYT
	#replace code:gb_repl_000006
        contents=re.sub('ON[\s]*COMMIT[\s]*PRESERVE[\s]*ROWS[\s]*[\n]*','',contents,0,re.I|re.M);

	#replace title to comment
        #2020-12-16 created by LYT
        #replace code:gb_repl_000007
        contents=re.sub('[\s]+title[\s]+',' COMMENT ',contents,0,re.I|re.M);

	#delete UNIQUE keyword
	#2020-12-16 created by LYT
	#replace code:gb_repl_000008
	contents=re.sub('unique[\s]+',' ',contents,0,re.I|re.M);

	#TD ** operation to power
	#2020-12-16 created by LYT
	#replace code:gb_repl_000009
	contents=re.sub('([a-zA-Z\.0-9]+)[\s]*\*\*[\s]*([a-zA-Z\.0-9]+)','power\(\\1,\\2\)',contents,0,re.I|re.M);
	
	#delete "WITH DEFAULT
	#2020-12-17 created by LYT
	#replace code:gb_repl_000009
	contents=re.sub('with[\s]+default','',contents,0,re.I|re.M);

	#replace DDL's TIMESTAMP(0) DEFAULT CURRENT_TIMESTAMP(0) string
	#2020-12-16 create by LYT
        #replace code:gb_repl_0000010
	contents=re.sub('TIMESTAMP[\s]*\([\s]*0[\s]*\)[\s]*DEFAULT[\s]*CURRENT_TIMESTAMP[\s]*\([\s]*0[\s]*\)','TIMESTAMP DEFAULT CURRENT_TIMESTAMP',contents,0,re.I|re.M);

	#comment out contents "CHARACTER SET ... CASESPECIFIC"
	#2020-12-16 create by LYT
        #replace code:gb_repl_000011
	contents=re.sub('(CHARACTER.*CASESPECIFIC)','',contents,0,re.I|re.M);

	#comment out contents "CHARACTER SET ... UPPERCASE"
        #2020-12-16 create by LYT
        #replace code:gb_repl_000011
	contents=re.sub('(CHARACTER.*uppercase)','',contents,0,re.I|re.M);

        #comment out contents "comress ...."
        #2020-12-16 create by LYT
        #replace code:gb_repl_000011
	#remark:include compress () and compress null
        contents=re.sub('compress[\s]*\(.[^\)]*\)','',contents,0,re.I|re.M); 
	contents=re.sub('compress[\s]+null','',contents,0,re.I|re.M); 

	#comment out contents "FORMAT '.......'" mnly in DDL statment
	#2020-12-16 create by LYT
	#replace code:gb_repl_000011
	#remark:only modify create DDL,not include create select
	searchResult=re.finditer('create[\s]+([\w\W](?!select|create ))*;',contents,re.I|re.M);
	for createddlstatement in searchResult:
		oldcontents=createddlstatement.group();
		#comment out contents "FORMAT '.......'" only in DDL statment
		newcontents=re.sub('(format[\s]+\'[\s]*[\S]*[\s]*\')','',oldcontents,0,re.I|re.M);
		#comment out contents "constraint primary key'.......'" only in DDL statment
		newcontents=re.sub('(constraint[\s]+[\S]*[\s]+primary[\s]+key)','',newcontents,0,re.I|re.M);
		#comment out contents "constraint unique'.......'" only in DDL statment
		newcontents=re.sub('(constraint[\s]+[\S]*[\s]+unique)','',newcontents,0,re.I|re.M);
		#comment out contents "constraint check'.......'" only in DDL statment
                newcontents=re.sub('(constraint[\s]+[\S]*[\s]+check[\s]+\([\s]*[\S][^\)]*[\s]*\))','',newcontents,0,re.I|re.M);
		#comment out contents "constraint references'.......'" only in DDL statment
                newcontents=re.sub('(constraint[\s]+[\S]*[\s]+references[\s]+.*\([\s]*[\S][^\)]*[\s]*\))','',newcontents,0,re.I|re.M);
		
		#comment out contents "timestamp(0)'.......'" only in DDL statment
		newcontents=re.sub('timestamp[\s]*\([\s]*[0-9]*[\s]*\)','datetime',newcontents,0,re.I|re.M);
		
		contents=contents.replace(oldcontents,newcontents);

	#delete lock for access statment
	#2021-01-22
	#replace code:
	contents=re.sub('(locking[\s\S][^;]*access)','/* \\1 */',contents,0,re.I|re.M);

        #delete collect statistics statment
        #2021-01-22
        #replace code:
	contents=re.sub('(collect[\s]+statistics[\s\S][^;]*;)','/* \\1 */',contents,0,re.I|re.M);

	#Primary index string replace
	#2020-12-16 create by LYT
	#replace code:gb_repl_000012
	searchResult=re.finditer('primary[\s]+index[\s\S][^\(]*(\([\s\S][^\)]*\))',contents,re.I|re.M);
        for match in searchResult:
                searchResultStr=match.group();
                para1=match.group(1);
		#replace '(' to '('',add left single quote
                para1=re.sub('\([\s]*','(\'',para1,0,re.I|re.M);
		#replace ')' to '')',add right single quote
                para1=re.sub('[\s]*\)','\')',para1,0,re.I|re.M);
		#replace ',' to '','' add quotes on all sides
                para1=re.sub('[\s]*\,[\s]*','\',\'',para1,0,re.I|re.M);
		
                para1="DISTRIBUTED BY " + para1;
                contents=contents.replace(searchResultStr,para1);

	# DDL replace,this section only processes volatile table
	#2020-12-16 create by LYT
        #replace code:gb_repl_0000013
	searchResult=re.finditer('create.*volatile.*table[\s]+[\S][^,]*[\s\S][^;]*;',contents,re.I|re.M);
	for match in searchResult:
                searchResultStr=match.group();
		createsectionsearch=re.finditer('create.*volatile.*table[\s]+([\S][^,]*)[,]*[\s\S][^\(]*([\s\S][^;]*);',searchResultStr,re.I|re.M);
		for info in createsectionsearch:
			if '(' in info.group():
                		tbname=info.group(1); #get table name
                		maincontents=info.group(2); #main content
                		distriInfo=re.search('distributed',maincontents,re.I|re.M);
				if distriInfo:
                        		getdistributedinfo=re.finditer('(distributed.*\))',maincontents,re.I|re.M);
                        		for distri in getdistributedinfo:
                                		distri_para=distri.group(1);
				else:
                        		distri_para=" REPLICATED ";
                		maincontents=maincontents.replace(distri_para,'');
                		newCreateOrSelect=re.search('select',searchResultStr,re.I|re.M);
                		if newCreateOrSelect:
                        		repStr0="CREATE TEMPORARY TABLE " + tbname + " " + distri_para +" CHARSET=UTF8 " + maincontents + " ;";
                		else:
                        		repStr0="CREATE TEMPORARY TABLE " + tbname + " " + maincontents + distri_para +" CHARSET=UTF8 ;" 
			else:
				createtableas=re.finditer('create.*volatile.*table[\s]+([\S][^,]*)[,]*[\s\S]* as ([\s\S][^;]*);',searchResultStr,re.I|re.M);
				for likestatement in createtableas:
					tbname=likestatement.group(1); #get table name
					maincontents=likestatement.group(2); #main content
					repStr0="CREATE TEMPORARY TABLE " + tbname + " like " + maincontents+" ; "; 

                	contents=contents.replace(searchResultStr,repStr0);

        # DDL replace,this section only processes create multiset/set table
        #2020-12-16 create by LYT
        #replace code:gb_repl_0000015
        searchResult=re.finditer('create((?!volatile|temporary).)+table[ ]*([a-zA-Z0-9._\-${}]*)[\s\S][^\(]*\(([\s\S][^;]*)',contents,re.I|re.M);
        for match in searchResult:
                searchResultStr=match.group();
                para2=match.group(2); #get table name
                para3=match.group(3); #main content
		distriInfo=re.search('distributed',para3,re.I|re.M);
		if distriInfo:
			getdistributedinfo=re.finditer('(distributed.*\))',para3,re.I|re.M);	
			for match in getdistributedinfo:
				distri_para=match.group(1);
		else:
			distri_para=" REPLICATED ";
		para3=para3.replace(distri_para,'');		
			
		newCreateOrSelect=re.search('select',searchResultStr,re.I|re.M);
                if newCreateOrSelect:
                        repStr="CREATE TABLE " + para2 + " " + distri_para +" CHARSET=UTF8 ( " + para3; 
                else:
                        repStr="CREATE TABLE " + para2 + " ( " + para3 + distri_para +" CHARSET=UTF8"
		#print repStr;
                contents=contents.replace(searchResultStr,repStr);

	#cast('20191231' as date format 'yyyymmdd') td return date type
	#Ex. select cast('20191231' as date format 'yyyymmdd')+40;   -- return 20/02/09
	#2020-12-17 create by LYT
	#replace code:gb_repl_00000
	searchResult=re.finditer('cast[\s]*\([\s]*([\S][^\(]*)[\s]*as[\s]*date[\s]*format[\s]*\'YYYYMMDD\'[\s]*\)([ ]*[+-]*[ ]*[0-9]*)',contents,re.I|re.M);
	for match in searchResult:
		searchResultStr=match.group();
		para1=match.group(1).rstrip();
		para2=match.group(2);
		repStr=" date(" + para1 + ")" + para2;
		contents=contents.replace(searchResultStr,repStr);

        #qulify content modify
        #2020-12-18 create by LYT
        #replace code:gb_repl_00000
        searchResult=re.finditer('selec([\w\W](?!select))*qualify[\w\W][^;]*;',contents,re.I|re.M); #get contents between select and qulify statment
        for match in searchResult:
                searchResultStr=match.group(); 
		#print searchResultStr;
		selecttofrom=re.finditer('select([\s\S]*)from',searchResultStr,re.I|re.M); #get rejection contents between select and from
		for match in selecttofrom:
			rejectionContent=match.group(1); #get rejection columns
			#print rejectionContent;
			caseend=re.finditer('case[\s\S]*end.*',rejectionContent,re.I|re.M); #get contents between case and end
			for match in caseend:
				caseendContent=match.group();
				caseendContentRep=re.sub(',','&',caseendContent,0,re.I|re.M); #replace comma to &
				caseendContentRep=re.sub('\(','~1~',caseendContentRep,0,re.I|re.M); #replace ( to ~1~
				caseendContentRep=re.sub('\)','~2~',caseendContentRep,0,re.I|re.M); # replace ) to ~2~
				#print caseendContent;
				rejectionContent=rejectionContent.replace(caseendContent,caseendContentRep); 
			
			#convert all rejection include '(,)' characters
			rs = matchlp(rejectionContent);
			rs1=rs;
			while rs:
				rs=re.sub(',','&',rs,0,re.I|re.M);
				rs=re.sub('\(','~1~',rs,0,re.I|re.M);
				rs=re.sub('\)','~2~',rs,0,re.I|re.M);
				rejectionContent=rejectionContent.replace(rs1,rs);
				rs = matchlp(rejectionContent);
				rs1=rs;
			
			#add all columns to a list
			listProjection=rejectionContent.split(','); #split string to list
			colNum=len(listProjection); 
			destcollist=[];
			for colindex in range(0,colNum):
				colcontent=listProjection[colindex].strip();
				listcolcontent=colcontent.rsplit(' ',1); #每个list元素从后面反向分割1次
				if len(listcolcontent)>1:
					if listcolcontent[-1].find('\'')==-1:
						if '~2~' not in listcolcontent[-1]:
							destcollist.append(listcolcontent[-1]);
						else:
							addalias="addedbypro"+str(colindex);
							destcollist.append(addalias);
							addaliastocol=' '.join(listcolcontent) + ' ' + addalias;
                                               		rejectionContent=rejectionContent.replace(' '.join(listcolcontent),addaliastocol);
					else:
                                                destcollist.append(''.join(listcolcontent));
					
				else:
					splitcolumnwithdot=listcolcontent[0].split('.');
					if len(splitcolumnwithdot)>1:
						destcollist.append(splitcolumnwithdot[-1]);
					else:
						destcollist.append(''.join(splitcolumnwithdot));

			newselect='select \n';				
			for newCol in range(0,len(destcollist)):
				if '\'' not in destcollist[newCol]: #if col is not constrant string 
					if newCol!= len(destcollist)-1:
						newselect+='qulifyAlias.'+destcollist[newCol]+'\n,';
					else:
						newselect+='qulifyAlias.'+destcollist[newCol]+'\n FROM (';
				else:
					if newCol!= len(destcollist)-1:
                                                newselect+=destcollist[newCol]+'\n,';
                                        else:
                                                newselect+=destcollist[newCol]+'\n FROM (';

			#get string between 'from' to 'qulify'
			fromtoqualify=re.finditer('from([\s\S]*)qualify',searchResultStr,re.I|re.M);
                	for match in fromtoqualify:
                        	coreContent=match.group(1);
			qualifytoend=re.finditer('qualify([\s\S]*)=',searchResultStr,re.I|re.M);
			equalvalue='';
			for match in qualifytoend:
				qualifyContent=match.group(1);
			allqualify=re.finditer('qualify([\s\S]*);',searchResultStr,re.I|re.M);
			for match in allqualify:
				equalvaluesearch=re.finditer('(=.*)',match.group(),re.I|re.M);
				for match in equalvaluesearch:
					equalvalue=match.group(1);
			#print rejectionContent;
			qualifymodified=newselect +'\nSELECT '+rejectionContent+','+qualifyContent.strip()+' AS qulifyColumn\n'+' FROM '+coreContent+'\n) qulifyAlias\nWHERE qulifyAlias.qulifyColumn'+' '+equalvalue+' );\n';
			#print qualifymodified;
			finalmodify1=re.sub('~1~','(',qualifymodified,0,re.I|re.M);
			finalmodify2=re.sub('~2~',')',finalmodify1,0,re.I|re.M);
			finalmodify3=re.sub('&',',',finalmodify2,0,re.I|re.M);
			finalmodify4=re.sub('\t\t',' ',finalmodify3,0,re.I|re.M);
			#print finalmodify4;
			contents=contents.replace(searchResultStr,finalmodify4);
	
	#alias content modify
        #2021-01-03 create by LYT
        #replace code:gb_repl_00000
        searchResult=re.finditer('selec([\w\W](?!;))*[\w\W][^;]*;',contents,re.I|re.M); #get contents between select and ';' statment
	rejectiontotallist=[];
	aliasdic={};
        for match in searchResult:
                searchResultStr=match.group();
		selectfrom=re.finditer('select(([\s\S](?!select))*)from',searchResultStr,re.I|re.M);
		for match in selectfrom:
			sfstr=match.group(1);
			rs = matchlp(sfstr);
                	rs1=rs;
                	while rs:
                		rs=re.sub(',','&',rs,0,re.I|re.M);
                		rs=re.sub('\(','~1~',rs,0,re.I|re.M);
                		rs=re.sub('\)','~2~',rs,0,re.I|re.M);
				rs=re.sub('<','~3~',rs,0,re.I|re.M);
				rs=re.sub('>','~4~',rs,0,re.I|re.M);
                		sfstr=sfstr.replace(rs1,rs);
                		rs = matchlp(sfstr);
                		rs1=rs;
			rejectiontotallist=sfstr.split(',');

			columnnum=0;
			while columnnum<len(rejectiontotallist):
				splitcolumn=rejectiontotallist[columnnum].strip().rsplit(' ',1);
				if len(splitcolumn)>=2:
					tmpalias=str(splitcolumn[0]);
					tmpalias=re.sub(' as','',tmpalias,0,re.I|re.M); #去掉AS
					aliasdic[splitcolumn[1]]=tmpalias.strip();
				else:
					aliasdic['']=splitcolumn[0];
				columnnum+=1;
		
		#替换查询条件中包括=<>运算的使用别名的列
		#从列表中剔除正常的子查询别名使用
		joinoperatorcol=re.findall('[\s]*[\(]*([\S]*)[\s]*[=><][=<>]*',searchResultStr,re.I|re.M);
		for listcontent in joinoperatorcol:
			listcolname=listcontent.split('.');
			if len(listcolname)==2:
				norreplace=re.findall('\)[\s]*'+str(listcolname[0]),searchResultStr,re.I|re.M);
				if norreplace != []:
					joinoperatorcol.remove(listcontent);
		
		searchResultStrforreplace=searchResultStr;
		for listcontent in joinoperatorcol:
			listcolname=listcontent.split('.');
			if len(listcolname)==1:
				tmpstr=str(listcolname[0]);
                                if  tmpstr in aliasdic.keys(): #判断where条件中的列是否在别名字典中
                                        if  aliasdic[tmpstr]:
                                                origncol=' '+aliasdic[tmpstr]+' \\1 ';
                                                searchResultStrforreplace=re.sub('[\s]*[\S]*[\.]*'+tmpstr+'[\s]*([=><][=<>]*)',origncol,searchResultStrforreplace,0,re.I|re.M);
                                                finalmodify1=re.sub('~1~','(',searchResultStrforreplace,0,re.I|re.M);
                                                finalmodify2=re.sub('~2~',')',finalmodify1,0,re.I|re.M);
                                                finalmodify3=re.sub('&',',',finalmodify2,0,re.I|re.M);
                                                finalmodify4=re.sub('\t\t',' ',finalmodify3,0,re.I|re.M);
						finalmodify5=re.sub('~3~','<',finalmodify4,0,re.I|re.M);
						finalmodify6=re.sub('~4~','>',finalmodify5,0,re.I|re.M);
                                                contents=contents.replace(searchResultStr,finalmodify6);
                                                searchResultStr=finalmodify6;
			else:
				tmpstr=str(listcolname[-1]);
				if  tmpstr in aliasdic.keys(): #判断where条件中的列是否在别名字典中
                                	origncol=' '+aliasdic[tmpstr]+' \\1 ';
                                        searchResultStrforreplace=re.sub(' [\S]*[\.]*'+tmpstr+'[\s]*([=><][=<>]*)',origncol,searchResultStrforreplace,0,re.I|re.M);
                                        finalmodify1=re.sub('~1~','(',searchResultStrforreplace,0,re.I|re.M);
                                        finalmodify2=re.sub('~2~',')',finalmodify1,0,re.I|re.M);
                                        finalmodify3=re.sub('&',',',finalmodify2,0,re.I|re.M);
                                        finalmodify4=re.sub('\t\t',' ',finalmodify3,0,re.I|re.M);
					finalmodify5=re.sub('~3~','<',finalmodify4,0,re.I|re.M);
                                        finalmodify6=re.sub('~4~','>',finalmodify5,0,re.I|re.M);
                                        contents=contents.replace(searchResultStr,finalmodify6);
                                        searchResultStr=finalmodify6;


with open('/data/perl/td_out.pl','w+') as fout:
	fout.write(contents);
