#!/usr/bin/python
#-*- coding:utf-8 –*-

#使用方式：
#新建一个目录，把原始的ddl放到这个目录,比如ori
#新建另外一个目录，用来存入转换后的ddl,比如gba
#命令：python ntzddl2gb.py ori gba

import re #regular expression
import os
import sys
import glob
import itertools

inputpath = sys.argv[1] + '/*'; 
outputpath = sys.argv[2]; 

def matchlp(s):
    spos = [];
    rs = "";
    for i in range(0, len(s)):
        if(s[i] == '('):
            spos.append(i);
            continue;
        if(s[i] == ')' and spos):
            ts = s[spos[-1]: i+1];
            if(len(ts) > len(rs)):
                    rs = ts;
            spos.pop();
    return rs;
        
def commonReplace(inputStr):
    inputStr=re.sub('(--)(.*)$','\\1 \\2',inputStr,0,re.I|re.M)
    inputStr=re.sub('(.[^\n]*"[\s]*)\|[\s]*bteq[\s]*(".[^\n]*)','\\1 | gccli -uroot -Dtest -vvv \\2',inputStr,0,re.I|re.M)
    inputStr=re.sub('(^[ ]*\.[ ]*.*)','-- \\1',inputStr,0,re.I|re.M) 
    inputStr=re.sub('^[\s]*(\${LOGON_STR}[\s]*$)','-- \\1',inputStr,0,re.I|re.M)
    inputStr=re.sub('^[\s]*(set[\s]*.*$)','-- \\1',inputStr,0,re.I|re.M)
    inputStr=re.sub('(with.*data)','',inputStr,0,re.I|re.M)
    inputStr=re.sub('ON[\s]*COMMIT[\s]*PRESERVE[\s]*ROWS[\s]*[\n]*','',inputStr,0,re.I|re.M)
    inputStr=re.sub('[\s]+title[\s]+',' COMMENT ',inputStr,0,re.I|re.M)
    inputStr=re.sub('unique[\s]+',' ',inputStr,0,re.I|re.M)
    inputStr=re.sub('([a-zA-Z\.0-9]+)[\s]*\*\*[\s]*([a-zA-Z\.0-9]+)','power\(\\1,\\2\)',inputStr,0,re.I|re.M)
    inputStr=re.sub('with[\s]+default','',inputStr,0,re.I|re.M);
    inputStr=re.sub('TIMESTAMP[\s]*\([\s]*0[\s]*\)[\s]*DEFAULT[\s]*CURRENT_TIMESTAMP[\s]*\([\s]*0[\s]*\)','TIMESTAMP DEFAULT CURRENT_TIMESTAMP',inputStr,0,re.I|re.M)
    inputStr=re.sub('(CHARACTER.*CASESPECIFIC)','',inputStr,0,re.I|re.M)
    inputStr=re.sub('(CHARACTER.*uppercase)','',inputStr,0,re.I|re.M)
    inputStr=re.sub('compress[\s]*\(.[^\)]*\)','',inputStr,0,re.I|re.M) 
    inputStr=re.sub('compress[\s]+null','',inputStr,0,re.I|re.M)
    inputStr=re.sub('\\bBTEQ\\b','gccli',inputStr,0,re.I|re.M)
    inputStr=re.sub('(locking[\s\S][^;]*\\baccess\\b)','/* \\1 */',inputStr,0,re.I|re.M)
    inputStr=re.sub('(collect[\s]+statistics[\s\S]*?;)','/* \\1 */',inputStr,0,re.I|re.M)  
    inputStr=re.sub('\\bvolatile\\b','temporary',inputStr,0,re.I|re.M)
    inputStr=re.sub('\\multiset\\b','',inputStr,0,re.I|re.M)
    inputStr=re.sub('create(.*)\\bset\\b(.*)table','create \\1 \\2 table',inputStr,0,re.I|re.M)
    inputStr=re.sub('cast[\s]*\([\s]*([0-9a-zA-Z\'_\{\}\$]+)[\s]+as[\s]+date[\s]+format[\s]+[0-9a-zA-Z\'_\{\}\$]+[\s]*\)','date(\\1)',inputStr,0,re.I|re.M)
    inputStr=re.sub('(\\bupd[ate]{0,}\\b[\s]+[\S]+[\s]+[\S]*[\s]*)from','\\1 join',inputStr,0,re.I|re.M)
    
    return inputStr

def primaryKeytoDisKey(ddlContents):
    priKey = re.finditer('primary[\s]+index[\s]*\([\s]*([\S]+)[\s]*,.*\)',ddlContents,re.I|re.M)
    for key in priKey:
        oldContent = key.group()
        keyName = key.group(1)
        newDisKey = "DISDRIBUTED BY(\'%s\')" % keyName
        ddlContents = ddlContents.replace(oldContent,newDisKey)
    return ddlContents

def convertContentsOnlyInDDL(srcContents):
    DDLSection=re.finditer('(^[ ]*)create.*table[ ]+([0-9a-zA-Z_\{\}\$]+)[\s\S]+?(\([\s\S]+?;)',srcContents,re.I|re.M)
    for match in DDLSection:
        OldDDL = match.group()
        tableName = match.group(2)
        tableDDLContent = match.group(3)
        newDDLContent = match.group(1)+"CREATE TEMPORARY TABLE "+tableName+tableDDLContent
        srcContents = srcContents.replace(OldDDL,newDDLContent)
        srcContents = re.sub('(format[\s]+\'[\s]*[\S]*[\s]*\')','',srcContents,0,re.I|re.M)
        srcContents = re.sub('(constraint[\s]+[\S]*[\s]+primary[\s]+key)','',srcContents,0,re.I|re.M)
        srcContents = re.sub('(constraint[\s]+[\S]*[\s]+unique)','',srcContents,0,re.I|re.M)
        srcContents = re.sub('(constraint[\s]+[\S]*[\s]+check[\s]+\([\s]*[\S][^\)]*[\s]*\))','',srcContents,0,re.I|re.M)
        srcContents = re.sub('(constraint[\s]+[\S]*[\s]+references[\s]+.*\([\s]*[\S][^\)]*[\s]*\))','',srcContents,0,re.I|re.M)
        srcContents = re.sub('timestamp[\s]*\([\s]*[0-9]*[\s]*\)','datetime',srcContents,0,re.I|re.M)
        srcContents = primaryKeytoDisKey(srcContents)
    return srcContents

'''
别名依赖处理,暂时废弃
'''
def convertAliasInSelect(srcContents):
    searchResult=re.finditer('select([\w\W](?!;))*[\w\W][^;]*;',srcContents,re.I|re.M); #get contents between select and ';' statment
    rejectiontotallist=[]
    aliasdic={}
    for match in searchResult:
        searchResultStr=match.group()
        selectfrom=re.finditer('select(([\s\S](?!select))*)from',searchResultStr,re.I|re.M)
        for match in selectfrom:
            sfstr=match.group(1)
            rs = matchlp(sfstr)
            rs1 = rs
            while rs:
                rs=re.sub(',','&',rs,0,re.I|re.M)
                rs=re.sub('\(','~1~',rs,0,re.I|re.M)
                rs=re.sub('\)','~2~',rs,0,re.I|re.M)
                rs=re.sub('<','~3~',rs,0,re.I|re.M)
                rs=re.sub('>','~4~',rs,0,re.I|re.M)
                sfstr=sfstr.replace(rs1,rs)
                rs = matchlp(sfstr)
                rs1=rs
            rejectiontotallist=sfstr.split(',')
            
            columnnum=0
            while columnnum<len(rejectiontotallist):
                splitcolumn=rejectiontotallist[columnnum].strip().rsplit(' ',1)
                if len(splitcolumn)>=2:
                    tmpalias=str(splitcolumn[0])
                    tmpalias=re.sub(' as','',tmpalias,0,re.I|re.M) #去掉AS
                    aliasdic[splitcolumn[1]]=tmpalias.strip()
                else:
                    aliasdic['']=splitcolumn[0]
                columnnum+=1
                
            joinoperatorcol=re.findall('[\s]*[\(]*([\S]*)[\s]*[=><][=<>]*',searchResultStr,re.I|re.M)
            for listcontent in joinoperatorcol:
                listcolname=listcontent.split('.')
                if len(listcolname)==2:
                    norreplace=re.findall('\)[\s]*'+str(listcolname[0]),searchResultStr,re.I|re.M)
                    if norreplace != []:
                        joinoperatorcol.remove(listcontent)
            
            searchResultStrforreplace=searchResultStr
            for listcontent in joinoperatorcol:
                listcolname=listcontent.split('.')
                if len(listcolname)==1:
                    tmpstr=str(listcolname[0])
                    if tmpstr in aliasdic.keys(): #判断where条件中的列是否在别名字典中
                        if  aliasdic[tmpstr]:
                            origncol=' '+aliasdic[tmpstr]+' \\1 '
                            searchResultStrforreplace=re.sub('[\s]*[\S]*[\.]*'+tmpstr+'[\s]*([=><][=<>]*)',origncol,searchResultStrforreplace,0,re.I|re.M)
                            finalmodify1=re.sub('~1~','(',searchResultStrforreplace,0,re.I|re.M)
                            finalmodify2=re.sub('~2~',')',finalmodify1,0,re.I|re.M)
                            finalmodify3=re.sub('&',',',finalmodify2,0,re.I|re.M)
                            finalmodify4=re.sub('\t\t',' ',finalmodify3,0,re.I|re.M)
                            finalmodify5=re.sub('~3~','<',finalmodify4,0,re.I|re.M)
                            finalmodify6=re.sub('~4~','>',finalmodify5,0,re.I|re.M)
                            srcContents=srcContents.replace(searchResultStr,finalmodify6)
                            searchResultStr=finalmodify6
                else:
                    tmpstr=str(listcolname[-1])
                    if tmpstr in aliasdic.keys(): #判断where条件中的列是否在别名字典中
                        origncol=' '+aliasdic[tmpstr]+' \\1 '
                        searchResultStrforreplace=re.sub(' [\S]*[\.]*'+tmpstr+'[\s]*([=><][=<>]*)',origncol,searchResultStrforreplace,0,re.I|re.M)
                        finalmodify1=re.sub('~1~','(',searchResultStrforreplace,0,re.I|re.M)
                        finalmodify2=re.sub('~2~',')',finalmodify1,0,re.I|re.M)
                        finalmodify3=re.sub('&',',',finalmodify2,0,re.I|re.M)
                        finalmodify4=re.sub('\t\t',' ',finalmodify3,0,re.I|re.M)
                        finalmodify5=re.sub('~3~','<',finalmodify4,0,re.I|re.M)
                        finalmodify6=re.sub('~4~','>',finalmodify5,0,re.I|re.M)
                        srcContents=srcContents.replace(searchResultStr,finalmodify6)
                        searchResultStr=finalmodify6
'''
主程序
'''                   
for filename in glob.glob(inputpath):
    with open(filename,'r') as f:
        contents=f.read()
        contents=re.sub('\t',' ',contents,0,re.I|re.M)
        contents=re.sub('  ',' ',contents,0,re.I|re.M)
        contents=commonReplace(contents)
        contents = convertContentsOnlyInDDL(contents)
        with open(outputpath+'/'+filename.split('/')[-1]+'_gbase','w+') as fout:
            fout.write(contents);